<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>How to Install, Customize and Backup Suckless Tools</title>
<meta name="author" content="dt" />
<meta name="description" content="Guest Articles - How to Install, Customize and Backup Suckless Tools
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">How to Install, Customize and Backup Suckless Tools</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#orgf5a7764">How to Install, Customize and Backup Suckless Tools</a></li>
<li><a href="#org632e62e">Introduction</a></li>
<li><a href="#orgae182ba">Installation</a>
<ul>
<li><a href="#orgee8389d">dwm</a></li>
<li><a href="#org8808aca">st</a></li>
<li><a href="#org8c99895">dmenu</a></li>
</ul>
</li>
<li><a href="#org70585af">Configuration</a>
<ul>
<li><a href="#org75a5637">dwm</a>
<ul>
<li><a href="#org280bad7">Font and Color-scheme</a></li>
<li><a href="#org840c2e5">The rules</a></li>
<li><a href="#orgc5d1c47">Keybindings</a></li>
</ul>
</li>
<li><a href="#org6ce3c81">st</a>
<ul>
<li><a href="#orgae4355d">Font and Padding</a></li>
<li><a href="#orgadc057e">Color-scheme</a></li>
<li><a href="#org6fa890b">Cursor Shape</a></li>
</ul>
</li>
<li><a href="#org8904824">dmenu</a>
<ul>
<li><a href="#orgc7b6586">Font and color-scheme</a></li>
</ul>
</li>
</ul>
</li>
<li><a href="#orgb20764a">Patching</a></li>
<li><a href="#orgb873839">Links</a></li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="../kb/index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-orgf5a7764" class="outline-2">
<h2 id="orgf5a7764">How to Install, Customize and Backup Suckless Tools</h2>
<div class="outline-text-2" id="text-orgf5a7764">
<p>
<i>By Ronnie Nissan at April 18, 2020</i>
</p>
</div>
</div>

<div id="outline-container-org632e62e" class="outline-2">
<h2 id="org632e62e">Introduction</h2>
<div class="outline-text-2" id="text-org632e62e">
<p>
The suckless tools, especially dwm, st and dmenu, are some amazing pieces of software, that allow a great flexibility while being minimal. But they come at a cost, yes, Libra software is free as both in freedom and as in beer (most of the time), but you should make an effort to be able to use it, and that effort (cost) is much needed when it comes to the sucklees tools.
</p>

<p>
I used dwm, st and dmenu about a year ago, but I had no idea how to manage and backup them, I didn&rsquo;t know a lot about customizing (patching) them, but recently I started learning C programming language, and so I decided to use all three, as I will have to edit the source code to make any changes and so this will help me in my endeavor of learning C.
</p>

<p>
The reason I am making this tutorial is to help you get started with using dwm, st and dmenu too. This tutorial is my own personal experience and knowledge and has no connection to the guys at suckless, nor it is the best how-to guide.
</p>

<p>
This tutorial will assume you have a basic knowledge in Linux and you are able to install packages through your distro&rsquo;s package manager and solve dependencies, and that you use xinit to login to your xorg-session.
</p>
</div>
</div>

<div id="outline-container-orgae182ba" class="outline-2">
<h2 id="orgae182ba">Installation</h2>
<div class="outline-text-2" id="text-orgae182ba">
<p>
To install any of the above three, you&rsquo;ll need to have some libraries and git installed in your system, you can install them as following;
</p>

<p>
On Void Linux:
</p>
<pre class="example" id="orgba264b9">
sudo xbps-install -S git make libX11-devel libXinerama-devel
</pre>

<p>
On Debian and Debian-based distros:
</p>

<pre class="example" id="orgbc68111">
sudo apt-get install build-essential libx11-dev libxinerama-dev sharutils
</pre>

<p>
And on Arch and Arch-based distros:
</p>

<pre class="example" id="org8ed4f7b">
sudo pacman -S git make libx11 libxinerama
</pre>
</div>

<div id="outline-container-orgee8389d" class="outline-3">
<h3 id="orgee8389d">dwm</h3>
<div class="outline-text-3" id="text-orgee8389d">
<p>
Clone dwm from suckless.org
</p>

<pre class="example" id="org55f9e31">
git clone https://git.suckless.org/dwm
cd dwm/
make
sudo make install
</pre>

<p>
Then all that&rsquo;s left is that you put the following to your .xinitrc then start x with startx (nice!).
</p>

<pre class="example" id="orgd06ea16">
exec dwm
</pre>

<p>
This will give you an untouched dwm experience like the guys at suckless intended it.
</p>
</div>
</div>

<div id="outline-container-org8808aca" class="outline-3">
<h3 id="org8808aca">st</h3>
<div class="outline-text-3" id="text-org8808aca">
<p>
Clone st from suckless.org
</p>

<pre class="example" id="orgc8ec7b7">
git clone https://git.suckless.org/st
cd st/
make
sudo make install
</pre>

<p>
And this will install st, unmodified, on your system. Just note that st doesn&rsquo;t have a .desktop file by default, which means you will not find it in menus (like dmenu), however st it is the default terminal in dwm and it is bound to ALT + Shift + Return.
</p>
</div>
</div>

<div id="outline-container-org8c99895" class="outline-3">
<h3 id="org8c99895">dmenu</h3>
<div class="outline-text-3" id="text-org8c99895">
<p>
Clone dmenu from suckless.org
</p>

<pre class="example" id="org224e28c">
git clone https://git.suckless.org/dmenu
cd dmenu/
make
sudo make install
</pre>

<p>
Now dmenu is installed on your system. In dwm, alt + p is bound to launching dmenu.
</p>
</div>
</div>
</div>

<div id="outline-container-org70585af" class="outline-2">
<h2 id="org70585af">Configuration</h2>
<div class="outline-text-2" id="text-org70585af">
<p>
By now you should have a working (in the suckless philosophy way) system, but maybe you want to edit some colors, add some features through patching those programs to make them even more usable, or just more pleasant to look at.
</p>

<p>
<code>NOTE:</code> It is recommended that you make a copy of the config.def.h file and name it config.h and make your edits to this new file, so that when you update dwm for example and you get the new config.def.h it will not overwrite your modifications. However I don&rsquo;t do that, I edit the config.def.h and the config.h is generated automatically when I compile and install. This way when a patch edits the config.def.h, I can just delete config.h and recompile.
</p>
</div>

<div id="outline-container-org75a5637" class="outline-3">
<h3 id="org75a5637">dwm</h3>
<div class="outline-text-3" id="text-org75a5637">
<p>
To edit dwm, you&rsquo;ll have to cd into the dwm directory and edit the config.def.h, remember to remove the config.h file before recompiling (see note above). And here I&rsquo;ll explain some parts of the config file.
</p>
</div>

<div id="outline-container-org280bad7" class="outline-4">
<h4 id="org280bad7">Font and Color-scheme</h4>
<div class="outline-text-4" id="text-org280bad7">
<p>
In the lines 8 and 9 you can set the font, and the font size of the dwm, and also dmenu if you don&rsquo;t want to edit your dmenu installation and launch it through the dwm defined flags on line 59.
</p>

<p>
From line 10 to line 19 in your config.h file, you&rsquo;ll see the following
</p>

<pre class="example" id="org4511bcc">
static const char col_gray1[]       = "#222222";
static const char col_gray2[]       = "#444444";
static const char col_gray3[]       = "#bbbbbb";
static const char col_gray4[]       = "#eeeeee";
static const char col_cyan[]        = "#005577";
static const char *colors[][3]      = {
	/*               fg         bg         border   */
	[SchemeNorm] = { col_gray3, col_gray1, col_gray2 },
	[SchemeSel]  = { col_gray4, col_cyan,  col_cyan  },
};
</pre>

<p>
In the lines from 10 to 15 you&rsquo;ll see some constants of type character defined. These are six colors, which you can change to whatever you like, you can also change the names of the constants for example:
</p>

<pre class="example" id="orga9feaaa">
static const char normalbg[]       = "#0ff000";
</pre>

<p>
Then on the lines 17 and 18 we are setting the defined constants to the element we want which are SchemeNorm and SchemeSel from the *colors constant, the first color is the foreground (fg) second is the background (bg) and the third is border color. Edit those to your liking, recompile, install and exit and log back into dwm to see your changes.
</p>
</div>
</div>

<div id="outline-container-org840c2e5" class="outline-4">
<h4 id="org840c2e5">The rules</h4>
<div class="outline-text-4" id="text-org840c2e5">
<p>
From line 30 to 31 you&rsquo;ll see some rules set for gimp and Firefox
</p>

<pre class="example" id="orgde8f2d7">
/* class      instance    title       tags mask     isfloating   monitor */
{ "Gimp",     NULL,       NULL,       0,            1,           -1 },
{ "Firefox",  NULL,       NULL,       1 &lt;&lt; 8,       0,           -1 },
</pre>

<p>
You can write rules for other programs and remove the ones set as you like. What you need to know is the class of the program which can be found using xprop. Then you can use it under “class”, keeping both “instance” and “title” as NULL (most of the time). If you set “isfloating” to 1, the program will spawn in floating mode. Under “monitor” you set which monitor the program will spawn on.
</p>

<p>
The “tags mask” is a bit tricky, but it is easy once you know how it works. Those are bit-wise operators (which I myself don&rsquo;t fully understand to be honest) but if all you want to do is to spawn Firefox on the ninth tag (default behavior) you&rsquo;ll have to set tag mask to “1 &lt;&lt; 8” which means 1 shifted to the left by 8, corresponding to the ninth tag. So the tags by default are “000000001”, when the 1 is in the rightmost position (ninth from left to right) you are on tag 1. “1 &lt;&lt; 8” means to put the “1” in the leftmost position 100000000 (first position from left), which is tag nine.
</p>

<p>
If you want Emacs for example to open on tag 3 and in floating mode you&rsquo;ll add this line to the above code:
</p>

<pre class="example" id="org8c96425">
{ "Emacs",     NULL,       NULL,       1 &lt;&lt; 2,            1,           -1 },
</pre>

<p>
Which translates to “000000100”. If you want to learn more about tag masks, check the &ldquo;How does a tag-mask work?&rdquo; at suckless.org (in the links section below).
</p>
</div>
</div>

<div id="outline-container-orgc5d1c47" class="outline-4">
<h4 id="orgc5d1c47">Keybindings</h4>
<div class="outline-text-4" id="text-orgc5d1c47">
<p>
I will not cover key bindings because I use sxhkd for custom keybindings, but if you want to use dwm key daemon or you just want to edit a few of the defaults, a look at the config from line 46 to line 96 will help you as it is self explanatory. If you want to change the mod key from alt to super key, you can edit line 47 and change it from Mod1Mask to Mod4Mask. This is more than enough to get you a customized dwm and you can start living in it from this point, but if you want to learn how to patch it, go to the “Patching” section of this page.
</p>
</div>
</div>
</div>

<div id="outline-container-org6ce3c81" class="outline-3">
<h3 id="org6ce3c81">st</h3>
<div class="outline-text-3" id="text-org6ce3c81">
<p>
The Simple Terminal is amazing, fast and has the best font rendering (second only to Alacritty) in my opinion. But it lacks some basic functionality by default which I&rsquo;ll address under the “Patching” section. But for just changing some of the default bindings and color schemes, you&rsquo;ll do the same as you did with dwm: go to the st directory, and edit the config.def.h file, remove the config.h file and recompile.
</p>
</div>

<div id="outline-container-orgae4355d" class="outline-4">
<h4 id="orgae4355d">Font and Padding</h4>
<div class="outline-text-4" id="text-orgae4355d">
<p>
To edit the font and the padding you&rsquo;ll have to edit lines 8 and 9, to set the font to Hack, size to 14, and padding to 8, you&rsquo;ll do the following:
</p>

<pre class="example" id="orgbdc5163">
static char *font = "Hack:pixelsize=14:antialias=true:autohint=true";
static int borderpx = 8;
</pre>
</div>
</div>

<div id="outline-container-orgadc057e" class="outline-4">
<h4 id="orgadc057e">Color-scheme</h4>
<div class="outline-text-4" id="text-orgadc057e">
<p>
To change st&rsquo;s default color-scheme you&rsquo;ll have to edit lines 86 to 112:
</p>

<pre class="example" id="org1ab7a97">
/* Terminal colors (16 first used in escape sequence) */
static const char *colorname[] = {
	/* 8 normal colors */
	"black",
	"red3",
	"green3",
	"yellow3",
	"blue2",
	"magenta3",
	"cyan3",
	"gray90",

	/* 8 bright colors */
	"gray50",
	"red",
	"green",
	"yellow",
	"#5c5cff",
	"magenta",
	"cyan",
	"white",

	[255] = 0,

	/* more colors can be added after 255 to use with DefaultXX */
	"#cccccc"
	"#555555",
};
</pre>
</div>
</div>

<div id="outline-container-org6fa890b" class="outline-4">
<h4 id="org6fa890b">Cursor Shape</h4>
<div class="outline-text-4" id="text-org6fa890b">
<p>
St have four cursor shapes defined by default:
</p>

<pre class="example" id="org3567c89">
/*
 * Default shape of cursor
 * 2: Block ("█")
 * 4: Underline ("_")
 * 6: Bar ("|")
 * 7: Snowman ("☃")
 */
</pre>

<p>
To change the cursor to any of the above you have to edit the line 131 and set it to the number corresponding to the shape you want.
</p>

<pre class="example" id="org95b12c5">
static unsigned int cursorshape = 2;
</pre>

<p>
This is the basic customization that you can do to st to make it more pleasant to look at.
</p>
</div>
</div>
</div>

<div id="outline-container-org8904824" class="outline-3">
<h3 id="org8904824">dmenu</h3>
<div class="outline-text-3" id="text-org8904824">
<p>
You customize dmenu the same way you did with st and dwm, by editing the config.def.h, removing config.h and recompiling. Dmenu is a flexible and simple program that you can do a lot with, I use it to set my wallpaper, change my monitor layout, as a power-menu etc. You can pipe things into dmenu and paste the output to stdout. Which makes it extensible through scripting.
</p>

<p>
Note! Please remember that if you want to use your own build of dmenu, you&rsquo;ll have to remove some things from dwm, the things to be removed from config.def.h of dwm are the following: in line 59, everything between &lt;&gt; should be removed
</p>

<pre class="example" id="orgc019c87">
static const char *dmenucmd[] = { "dmenu_run", "-m", dmenumon, &lt;"-fn", dmenufont, "-nb", col_gray1,
                                  "-nf", col_gray3, "-sb", col_cyan, "-sf", col_gray4,&gt; NULL };
</pre>
</div>

<div id="outline-container-orgc7b6586" class="outline-4">
<h4 id="orgc7b6586">Font and color-scheme</h4>
<div class="outline-text-4" id="text-orgc7b6586">
<p>
To change the font of dmenu you should edit the line 7 and set it to the font you want.
</p>

<pre class="example" id="orged39af9">
"monospace:size=10"
</pre>

<p>
Changing the color-scheme is the same as in dwm, but here we set the colors inside the *colors constant directly.
</p>

<pre class="example" id="orgfb2ddf3">
[SchemeNorm] = { "#bbbbbb", "#222222" },
[SchemeSel] = { "#eeeeee", "#005577" },
[SchemeOut] = { "#000000", "#00ffff" },
</pre>

<p>
First one is the foreground and the second one is the background. The first line is for the Normal entries and the second line is for selected entries. If you want to watch a good video about dmenu, I recommend you watching Luke Smith&rsquo;s video on it.
</p>
</div>
</div>
</div>
</div>

<div id="outline-container-orgb20764a" class="outline-2">
<h2 id="orgb20764a">Patching</h2>
<div class="outline-text-2" id="text-orgb20764a">
<p>
Patching is how you extend the suckless tools with features they lack out of the box that either make them more usable or enhance the look and feel of them, like adding the ability to scroll back in st and gaps in dwm. To apply a patch you must go to suckless.org first. Download the patch you want to apply to the source-code directory of the software you want to apply it to. Then you&rsquo;ll do the following.
</p>

<pre class="example" id="org7a4c543">
sudo make clean
git remove config.h
git branch &lt;name of the patch&gt;.def
git checkout &lt;name of the new branch&gt;
patch -p1 &lt; &lt;name of the patch&gt;
</pre>

<p>
At this point, if all the hunks were successful, you will do:
</p>

<pre class="example" id="orgbaf0048">
git status #and check which files were modified, then do
git add &lt;names of the modified files&gt;
git commit -m &lt;enter a of what you are committing here&gt;
git checkout master
git merge &lt;name of the new branch&gt;
make
sudo make install
</pre>

<p>
If one or more hunks fails, you&rsquo;ll have to look into the terminal to see which file (or files) was it that the hunks failed to apply to, and you&rsquo;ll see inside the source code you&rsquo;ll have a file called &#x2026;rej so now all you have to do is, open the .rej file in your favorite text editor, look for the lines that have “-” (remove) and “+” (add) right to them, those are the lines you have to remove and add. Then you&rsquo;ll need to repeat the above steps.
</p>

<p>
In case you want to remove a patch you&rsquo;ve applied you have to run the command:
</p>

<pre class="example" id="orgc5bba51">
patch -R &lt; &lt;name of the patch&gt;.def
</pre>

<p>
If you want to learn more about patches check out the Hacking page from suckless.org and you can also watch DistroTube&rsquo;s video on patching dmenu.
</p>

<p>
### Backup
When you customize any of the suckless tools to your liking, you&rsquo;ll know it is not as easy as editing a config file, especially after you patch them. So keeping a backup of them is not as easy as saving a dotfile to a git repository and linking it to .config/name-of-program. In this section I&rsquo;ll show you the steps to make a backup of your suckless tools while still having the ability to update them when a new version comes out (which doesn&rsquo;t happen that often).
</p>

<p>
First of all you have to be in the directory of the program you want to make a backup of. Then you&rsquo;ll rename the remote of the git repository from origin to upstream.
</p>

<pre class="example" id="org889a55c">
git remote rename origin upstream
</pre>

<p>
Then you&rsquo;ll go to github.com (or gitlab) and make a new repository, call it the same as the program you are backing up for convenience. Then copy the repository&rsquo;s URL and type:
</p>

<pre class="example" id="orga8e6707">
git add remote origin &lt;the repository's url&gt;
</pre>

<p>
Now if you type:
</p>

<pre class="example" id="org2b470ca">
git remote -v
</pre>

<p>
You&rsquo;ll see that you have two remotes: one called &ldquo;upstream&rdquo; (pointing to suckless.org) and the other one called &ldquo;origin&rdquo; (pointing to your repository). Now all that&rsquo;s left is that you push your build to the master branch of your repository, to do that you type:
</p>

<pre class="example" id="org58485b4">
git push origin master
</pre>

<p>
If the guys at suckless update the program, all you&rsquo;ll have to do is go to that program&rsquo;s directory, and run the following:
</p>

<pre class="example" id="orgedd9d64">
git pull upstream master
</pre>

<p>
I think by now you can get around using the suckless tools with ease, customize them and back them up. Which is really amazing because the suckless tools are amazing. Later I&rsquo;ll be posting more articles explaining how to customize dwm&rsquo;s bar and how to use sxhkd as your key daemon.
</p>

<p>
I really hope you enjoyed this article and that it was useful to you.
</p>
</div>
</div>

<div id="outline-container-orgb873839" class="outline-2">
<h2 id="orgb873839">Links</h2>
<div class="outline-text-2" id="text-orgb873839">
<ul class="org-ul">
<li><a href="https://dwm.suckless.org/customisation/tagmask/">How Tag Masks Work</a></li>
<li><a href="https://suckless.org/hacking/">Hacking on Suckless</a></li>
</ul>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
